require 'pg'

require 'common/davical_plugin'
require 'rm/rm_plugin'

class DavicalRm
  #
  # DAViCal only supports Postgres, so even if we ever are
  # database-agnostic, this plugin can't be.
  #
  include DavicalPlugin
  include RmPlugin


  def delete_user(user)
    # Delete the given username. DAViCal uses foreign keys properly
    # and only supports postgres, so we let the ON DELETE CASCADE
    # trigger handle most of the work.
    raise NonexistentUserError.new(user.to_s()) if not user_exists(user)

    sql_queries = ['DELETE FROM usr WHERE username = $1']

    connection = PGconn.connect(@db_host, @db_port, @db_opts, @db_tty,
                                @db_name, @db_user, @db_pass)

    sql_queries.each do |sql_query|
      connection.query(sql_query, [user.to_s()])
    end

    connection.close()
  end


end
